#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GUIConstants.au3>
#include <string.au3>

Opt ( "GUIOnEventMode", 1 )														; GUI    Event Mode
GUICreate ( "   25k", 300, 350, 50, 450, $GUI_SS_DEFAULT_GUI, $WS_EX_TOPMOST )	;   
GUISetBkColor(0x00E0FFFF)														;   

GUICtrlCreateLabel ( "", 25, 17, 50, 20 )
			$Sq = GUICtrlCreateCombo ( "", 75, 15, 50, 20, -1 )
			GUICtrlSetData( -1, "N-36|N-37|N-38","N-37" )
							 
GUICtrlCreateLabel ( "-", 130, 17, 10, 20 )
			$N = GUICtrlCreateInput ( "", 138, 15, 30, 20, -1 )

GUICtrlCreateLabel ( "-", 173,17,10,20 )
			$Letters = GUICtrlCreateCombo ( "", 181, 15, 45, 20, -1 )
			GUICtrlSetData ( -1, "A-a|A-b|A-g|A-v|B-a|B-b|B-g|B-v|G-a|G-b|G-g|G-v|V-a|V-b|V-g|V-v","A-a" ) 

$Go = GUICtrlCreateButton ( " ",  75, 55, 150 )					;  
GUICtrlSetOnEvent ( $Go, "GetCoords")											;     

GUISetOnEvent ( $GUI_EVENT_CLOSE, "CLOSEClicked" )								;  CLOSEClicked    			   
GUISetState ()

ControlFocus ( "   25k", "", $N )							;        100k

Dim $Points [25][2] = [[0,0],[0,7.5],[0,15],[0,22.5],[0,30],[-5,0],[-5,7.5],[-5,15],[-5,22.5],[-5,30],[-10,0],[-10,7.5],[-10,15],[-10,22.5],[-10,30],[-15,0],[-15,7.5],[-15,15],[-15,22.5],[-15,30],[-20,0],[-20,7.5],[-20,15],[-20,22.5],[-20,30]]
Dim $Coords [25][2]


Func GetCoords ()

$Square = GUICtrlRead ( $Sq )											;      1M
$Num = GUICtrlRead ( $N )												;      100k
$Letters1 = GUICtrlRead ( $Letters )									;       25k

If $Num <> "" Then														;    

	$Num1 = Number ( $Num ) - 1											;     (      0,    1)
	$Row = Floor ( $Num1 / 12 )											;   -        12
	$Column = Mod ( $Num1, 12 )											;   -       12

If $Square = "N-37" Then
	$Sh0 = 56 - ( 1 / 3 ) * $Row										;       100k
	$D0 = 36 + 0.5 * $Column											;       100k
ElseIf $Square = "N-38" Then
	$Sh0 = 56 - ( 1 / 3 ) * $Row										;       100k
	$D0 = 42 + 0.5 * $Column											;       100k
EndIf	

For $i = 0 To 24
	$Coords[$i][0] = $Sh0 + $Points[$i][0] / 60							;    25 
	$Coords[$i][1] = $D0 + $Points[$i][1] / 60
Next	

Select
	Case $Letters1 = "A-a"												;    25k   
		$Corner1Lat = $Coords[0][0]										;     
		$Corner1Lon = $Coords[0][1]
		$Corner2Lat = $Coords[1][0]
		$Corner2Lon = $Coords[1][1]
		$Corner3Lat = $Coords[6][0]
		$Corner3Lon = $Coords[6][1]
		$Corner4Lat = $Coords[5][0]
		$Corner4Lon = $Coords[5][1]
		
Case $Letters1 = "A-b"
		$Corner1Lat = $Coords[1][0]
		$Corner1Lon = $Coords[1][1]
		$Corner2Lat = $Coords[2][0]
		$Corner2Lon = $Coords[2][1]
		$Corner3Lat = $Coords[7][0]
		$Corner3Lon = $Coords[7][1]
		$Corner4Lat = $Coords[6][0]
		$Corner4Lon = $Coords[6][1]

Case $Letters1 = "A-v"
		$Corner1Lat = $Coords[5][0]
		$Corner1Lon = $Coords[5][1]
		$Corner2Lat = $Coords[6][0]
		$Corner2Lon = $Coords[6][1]
		$Corner3Lat = $Coords[11][0]
		$Corner3Lon = $Coords[11][1]
		$Corner4Lat = $Coords[10][0]
		$Corner4Lon = $Coords[10][1]
		
Case $Letters1 = "A-g"
		$Corner1Lat = $Coords[6][0]
		$Corner1Lon = $Coords[6][1]
		$Corner2Lat = $Coords[7][0]
		$Corner2Lon = $Coords[7][1]
		$Corner3Lat = $Coords[12][0]
		$Corner3Lon = $Coords[12][1]
		$Corner4Lat = $Coords[11][0]
		$Corner4Lon = $Coords[11][1]

Case $Letters1 = "B-a"
		$Corner1Lat = $Coords[2][0]
		$Corner1Lon = $Coords[2][1]
		$Corner2Lat = $Coords[3][0]
		$Corner2Lon = $Coords[3][1]
		$Corner3Lat = $Coords[8][0]
		$Corner3Lon = $Coords[8][1]
		$Corner4Lat = $Coords[7][0]
		$Corner4Lon = $Coords[7][1]
		
Case $Letters1 = "B-b"
		$Corner1Lat = $Coords[3][0]
		$Corner1Lon = $Coords[3][1]
		$Corner2Lat = $Coords[4][0]
		$Corner2Lon = $Coords[4][1]
		$Corner3Lat = $Coords[9][0]
		$Corner3Lon = $Coords[9][1]
		$Corner4Lat = $Coords[8][0]
		$Corner4Lon = $Coords[8][1]

Case $Letters1 = "B-v"
		$Corner1Lat = $Coords[7][0]
		$Corner1Lon = $Coords[7][1]
		$Corner2Lat = $Coords[8][0]
		$Corner2Lon = $Coords[8][1]
		$Corner3Lat = $Coords[13][0]
		$Corner3Lon = $Coords[13][1]
		$Corner4Lat = $Coords[12][0]
		$Corner4Lon = $Coords[12][1]
		
Case $Letters1 = "B-g"
		$Corner1Lat = $Coords[8][0]
		$Corner1Lon = $Coords[8][1]
		$Corner2Lat = $Coords[9][0]
		$Corner2Lon = $Coords[9][1]
		$Corner3Lat = $Coords[14][0]
		$Corner3Lon = $Coords[14][1]
		$Corner4Lat = $Coords[13][0]
		$Corner4Lon = $Coords[13][1]

Case $Letters1 = "V-a"
		$Corner1Lat = $Coords[10][0]
		$Corner1Lon = $Coords[10][1]
		$Corner2Lat = $Coords[11][0]
		$Corner2Lon = $Coords[11][1]
		$Corner3Lat = $Coords[16][0]
		$Corner3Lon = $Coords[16][1]
		$Corner4Lat = $Coords[15][0]
		$Corner4Lon = $Coords[15][1]
		
Case $Letters1 = "V-b"
		$Corner1Lat = $Coords[11][0]
		$Corner1Lon = $Coords[11][1]
		$Corner2Lat = $Coords[12][0]
		$Corner2Lon = $Coords[12][1]
		$Corner3Lat = $Coords[17][0]
		$Corner3Lon = $Coords[17][1]
		$Corner4Lat = $Coords[16][0]
		$Corner4Lon = $Coords[16][1]

Case $Letters1 = "V-v"
		$Corner1Lat = $Coords[15][0]
		$Corner1Lon = $Coords[15][1]
		$Corner2Lat = $Coords[16][0]
		$Corner2Lon = $Coords[16][1]
		$Corner3Lat = $Coords[21][0]
		$Corner3Lon = $Coords[21][1]
		$Corner4Lat = $Coords[20][0]
		$Corner4Lon = $Coords[20][1]
		
Case $Letters1 = "V-g"
		$Corner1Lat = $Coords[16][0]
		$Corner1Lon = $Coords[16][1]
		$Corner2Lat = $Coords[17][0]
		$Corner2Lon = $Coords[17][1]
		$Corner3Lat = $Coords[22][0]
		$Corner3Lon = $Coords[22][1]
		$Corner4Lat = $Coords[21][0]
		$Corner4Lon = $Coords[21][1]

Case $Letters1 = "G-a"
		$Corner1Lat = $Coords[12][0]
		$Corner1Lon = $Coords[12][1]
		$Corner2Lat = $Coords[13][0]
		$Corner2Lon = $Coords[13][1]
		$Corner3Lat = $Coords[18][0]
		$Corner3Lon = $Coords[18][1]
		$Corner4Lat = $Coords[17][0]
		$Corner4Lon = $Coords[17][1]
		
Case $Letters1 = "G-b"
		$Corner1Lat = $Coords[13][0]
		$Corner1Lon = $Coords[13][1]
		$Corner2Lat = $Coords[14][0]
		$Corner2Lon = $Coords[14][1]
		$Corner3Lat = $Coords[19][0]
		$Corner3Lon = $Coords[19][1]
		$Corner4Lat = $Coords[18][0]
		$Corner4Lon = $Coords[18][1]

Case $Letters1 = "G-v"
		$Corner1Lat = $Coords[17][0]
		$Corner1Lon = $Coords[17][1]
		$Corner2Lat = $Coords[18][0]
		$Corner2Lon = $Coords[18][1]
		$Corner3Lat = $Coords[23][0]
		$Corner3Lon = $Coords[23][1]
		$Corner4Lat = $Coords[22][0]
		$Corner4Lon = $Coords[22][1]
		
Case $Letters1 = "G-g"
		$Corner1Lat = $Coords[18][0]
		$Corner1Lon = $Coords[18][1]
		$Corner2Lat = $Coords[19][0]
		$Corner2Lon = $Coords[19][1]
		$Corner3Lat = $Coords[24][0]
		$Corner3Lon = $Coords[24][1]
		$Corner4Lat = $Coords[23][0]
		$Corner4Lon = $Coords[23][1]

EndSelect		

$Corner1Lat1 = DecToGrad ( $Corner1Lat )								;      -
$Corner2Lat1 = DecToGrad ( $Corner2Lat )
$Corner3Lat1 = DecToGrad ( $Corner3Lat )
$Corner4Lat1 = DecToGrad ( $Corner4Lat )
$Corner1Lon1 = DecToGrad ( $Corner1Lon )
$Corner2Lon1 = DecToGrad ( $Corner2Lon )
$Corner3Lon1 = DecToGrad ( $Corner3Lon )
$Corner4Lon1 = DecToGrad ( $Corner4Lon )

$Coordinates = GUICtrlCreateLabel ( "   " & $Num & "-" & $Letters1 & @CRLF & @CRLF & "1 - " & $Corner1Lat1 & "N  " & $Corner1Lon1 & "E" & @CRLF & "2 - " & $Corner2Lat1 & "N  " & $Corner2Lon1 & "E" & @CRLF & "3 - " & $Corner3Lat1 & "N  " & $Corner3Lon1 & "E" & @CRLF & "4 - " & $Corner4Lat1 & "N  " & $Corner4Lon1 & "E" & @CRLF & @CRLF & "  Global Mapper" & @CRLF & @CRLF & " - " & $Corner1Lat & Chr ( 176 ) & "N" & @CRLF & " - " & $Corner3Lat & Chr ( 176 ) & "N" & @CRLF & " - " & $Corner1Lon & Chr ( 176 ) & "E" &  @CRLF & " - " & $Corner2Lon & Chr ( 176 ) & "E",  30, 100, 250, 300 )
GUICtrlSetFont ( $Coordinates, 12, 400 )

Else																	;      100k
MsgBox ( 0, "!", "    !" )
ControlFocus ( "   25k", "", $N )					;      
EndIf
EndFunc

Func DecToGrad ($value)
	$Gradus = Int ( $value )
	$Minute = $value - $Gradus
	$Minute = Round ( $Minute * 60, 1 )
	$GradMin = $Gradus & Chr ( 176 ) & $Minute & '"'
	Return $GradMin
EndFunc	

Func CLOSEClicked ()
	Exit
EndFunc

While 1
    $msg = GUIGetMsg ()
    If $msg = $GUI_EVENT_CLOSE Then ExitLoop
Wend
	


Exit